/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         BR_yyparse
#define yylex           BR_yylex
#define yyerror         BR_yyerror
#define yydebug         BR_yydebug
#define yynerrs         BR_yynerrs

#define yylval          BR_yylval
#define yychar          BR_yychar

/* Copy the first part of user declarations.  */
#line 1 "BR_Parser.y" /* yacc.c:339  */

/* ########################################################################

			      BR_Parser.y

   ########################################################################

   Copyright (c) : Dominique Leveque

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <setjmp.h>
#include <signal.h>

#if HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif

#if HAVE_SYS_WAIT_H || HAVE_BSD_WAITPID
#  include <sys/wait.h>
#endif
#ifndef WEXITSTATUS
#  define WEXITSTATUS(stat_val)    (0)
#endif
#ifndef WIFEXITED
#  define WIFEXITED(stat_val)      (1)
#endif

#ifdef __GNUC__
#  define alloc __builtin_alloca
#else
#  if HAVE_ALLOCA_H
#    include <alloca.h>
#  endif
#endif

#include "proto_decl.h"

#include "BR_Global.h"
#include "BR_Lexer.h"
#include "BR_Parser.h"
#include "BR_Interface.h"


   /*-----------------------------------------------------------------------*/

#ifndef yyparse
#define yyparse  BR_yyparse
#define yyerror  BR_yyerror
#define yydebug  BR_yydebug
#define yynerrs  BR_yynerrs
#define yychar   BR_yychar
#endif


   /*-----------------------------------------------------------------------*/

#define YYDEBUG                 1

#define YYFAIL          goto yyerrlab

#define BR_YYERROR              YYFAIL

   /*-----------------------------------------------------------------------*/

FCT (int, yyerror, (char*) );


#if YYDEBUG != 0

#define YYPRINT(f, t, v)        BR_yyprint(f, t, v)
static
FCT (int, BR_yyprint, (FILE*, int, YYSTYPE) );

//static
//FCT (void, BR_dump_tree, (BR_Str*, BR_TokenPt) );

#endif


   /*-----------------------------------------------------------------------*/

static char* basic_value[] =
{
  /*   0  (signed)? int         */      "int ",
  /*   1  (signed)? char        */      "char ",
  /*   2  (signed)? short       */      "short ",
  /*   3  (signed)? long        */      "long ",
  /*   4  unsigned              */      "unsigned int ",
  /*   5  unsigned char         */      "unsigned char ",
  /*   6  unsigned short        */      "unsigned short ",
  /*   7  unsigned long         */      "unsigned long ",
  /*   8  const (signed)? int   */      "const int ",
  /*   9  const (signed)? char  */      "const char ",
  /*  10  const (signed)? short */      "const short ",
  /*  11  const (signed)? long  */      "const long ",
  /*  12  const unsigned        */      "const unsigned int ",
  /*  13  const unsigned char   */      "const unsigned char ",
  /*  14  const unsigned short  */      "const unsigned short ",
  /*  15  const unsigned long   */      "const unsigned long "
};

static int basic_length[] =
{
  /*   0  */   3,
  /*   1  */   4,                   
  /*   2  */   5,
  /*   3  */   4,
  /*   4  */   12,
  /*   5  */   13,
  /*   6  */   14,
  /*   7  */   13,
  /*   8  */   9,
  /*   9  */   10,
  /*  10  */   11,
  /*  11  */   10,
  /*  12  */   18,
  /*  13  */   19,
  /*  14  */   20,
  /*  15  */   19
};

#define CONVERT_BASIC(x)        \
   (x->_val     = basic_value[x->_bits],   \
    x->_val_len = basic_length[x->_bits],  \
    x)


   /*-----------------------------------------------------------------------*/

static BR_TokenPt xl1;
static BR_TokenPt xl2;
static BR_TokenPt xl3;
static BR_TokenPt xl4;
static BR_TokenPt xl5;

#define APPEND2(x1,x2)              ((xl1 = x1)->_last->_next = (xl2 = x2),  \
                                     xl1->_last = xl2->_last, xl1=xl1)

#define APPEND3(x1,x2,x3)           ((xl1 = x1)->_last->_next = (xl2 = x2),  \
                                     xl2->_last->_next        = (xl3 = x3),  \
                                     xl1->_last               = xl3->_last,  \
                                     xl1)

#define APPEND4(x1,x2,x3,x4)        ((xl1 = x1)->_last->_next = (xl2 = x2),  \
                                     xl2->_last->_next        = (xl3 = x3),  \
                                     xl3->_last->_next        = (xl4 = x4),  \
                                     xl1->_last               = xl4->_last,  \
                                     xl1)

#define APPEND5(x1,x2,x3,x4,x5)     ((xl1 = x1)->_last->_next = (xl2 = x2),  \
                                     xl2->_last->_next        = (xl3 = x3),  \
                                     xl3->_last->_next        = (xl4 = x4),  \
                                     xl4->_last->_next        = (xl5 = x5),  \
                                     xl1->_last               = xl5->_last,  \
                                     xl1)


   /*-----------------------------------------------------------------------*/

#define STR_FCT_PT              "(*) ( "
#define STR_ANONYMOUS           "??? "
#define STR_PREFIX              ":: "
#define STR_CONST               "const "


#define ACCESS_BITS             (  BR_INFO_PRIVATE     \
				 | BR_INFO_PUBLIC      \
				 | BR_INFO_PROTECTED   \
				 | BR_INFO_NAMESPACE_ELEMENT)

#define AGGREGATE_BITS          (  BR_INFO_CLASS       \
				 | BR_INFO_STRUCT      \
				 | BR_INFO_UNION       \
                                 | BR_INFO_ENUM        \
  				 | BR_INFO_NAMESPACE)

#define PROC_DEF_BITS           (  BR_INFO_OPERATOR    \
                                 | BR_INFO_CONSTRUCTOR \
                                 | BR_INFO_DESTRUCTOR  \
                                 | BR_INFO_FRIEND)


   /*-----------------------------------------------------------------------*/

#define CONTROL_PARENT          (~(  ACCESS_BITS    | BR_INFO_VIRTUAL        \
                                   | BR_INFO_PARENT))

#define CONTROL_AGGREGATE       (~(  ACCESS_BITS    | AGGREGATE_BITS         \
                                   | BR_INFO_DEF    | BR_INFO_TEMPLATE       \
                                   | BR_INFO_FRIEND | BR_INFO_TYPEDEF))

#define CONTROL_TYPEDEF         (~(  ACCESS_BITS    | BR_INFO_TYPEDEF        \
                                   | BR_INFO_PROC   | BR_INFO_DATA           \
                                   | BR_INFO_STATIC | BR_INFO_EXTERN         \
                                   | BR_INFO_DEF    | BR_INFO_FRIEND))
                                 
#define CONTROL_PROC            (~(  ACCESS_BITS    | BR_INFO_PROC           \
                                   | BR_INFO_STATIC | BR_INFO_EXTERN         \
                                   | BR_INFO_INLINE | BR_INFO_TEMPLATE       \
                                   | BR_INFO_CONST  | BR_INFO_CONSTRUCTOR    \
                                   | BR_INFO_C      | BR_INFO_DESTRUCTOR     \
                                   | BR_INFO_FRIEND | BR_INFO_OPERATOR       \
                                   | BR_INFO_PURE   | BR_INFO_VIRTUAL        \
                                   | BR_INFO_DEF))

#define CONTROL_FRIEND_PROC     (~(  BR_INFO_FRIEND | BR_INFO_DEF            \
				   | BR_INFO_PROC   | BR_INFO_OPERATOR       \
                                   | BR_INFO_CONST))

#define CONTROL_DATA            (~(  ACCESS_BITS    | BR_INFO_DATA           \
                                   | BR_INFO_STATIC | BR_INFO_EXTERN         \
                                   | BR_INFO_DEF))


   /*-----------------------------------------------------------------------*/

#define TEST_BITS(val,bits)     ((val & (bits)) != 0)

#define CLEAR_BITS(val,bits)    (val &= ~(bits))

#define SET_BITS(val,bits)      (val |= bits)


   /*-----------------------------------------------------------------------*/

#define STACK_PREFIX(x)      \
  {                                                                      \
    if (global_prefix == BR_Null)                                        \
      global_prefix = x;                                                 \
    else                                                                 \
    {                                                                    \
      alloc_token   = ALLOC_TOKEN(T_PREFIX, STR_PREFIX);                 \
      last_token    = global_prefix->_last;                              \
      global_prefix = APPEND3(global_prefix, alloc_token, x);            \
      x->_last      = last_token;                                        \
    }                                                                    \
    global_prefix->_last->_line_num = prefix_stamp++;                    \
  }

#define UNSTACK_PREFIX()     \
  {                                                                      \
    if (global_prefix->_last == global_prefix)                           \
      global_prefix = BR_Null;                                           \
    else                                                                 \
    {                                                                    \
      global_prefix->_last        = global_prefix->_last->_last;         \
      global_prefix->_last->_next = BR_Null;                             \
    }                                                                    \
  }


   /*-----------------------------------------------------------------------*/

#define S_PRECED       10
#define A_PRECED       10
#define P_PRECED       10
#define F_PRECED       20
#define T_PRECED       20


#define SET_PRECED(x, preced)        (x->_line_num = preced)

#define GET_PRECED(x)                (x->_line_num)

#define TEST_PRECED(x, preced)   \
  if ((x->_code == '(') && (x->_line_num >= preced))              \
  {                                                               \
    (void) CLEAR_FIRST_TOK(x);                                    \
    (void) CLEAR_LAST_TOK(x);                                     \
  }


   /*-----------------------------------------------------------------------*/

static BR_TokenPt   default_token   = BR_Null;
static BR_TokenRec  tmp_token;

static BR_TokenPt   global_prefix   = BR_Null;
static BR_TokenPt   alloc_token     = BR_Null;
static BR_TokenPt   last_token      = BR_Null;

static BR_TokenPt   template_args   = BR_Null;
static BR_Boolean   template_flag   = BR_FALSE;

static BR_Str       prefix_buffer[1024];
static BR_Str       SU_buffer[4 * 1024];

static BR_Int       prefix_stamp    = 1;
static BR_Int       last_stamp      = 0;
static BR_Int       prefix_len      = 0;

BR_InfoHandler      BR_info_handler = BR_Null;


static jmp_buf      BR_env;

static RETSIGTYPE (*BR_sigill_handler)  ();
static RETSIGTYPE (*BR_sigbus_handler)  ();
static RETSIGTYPE (*BR_sigsegv_handler) ();


   /*-----------------------------------------------------------------------*/

#define IS_EMPTY(x)             (x == BR_Null)

#define SPACE(x)                ((x->_last->_val_len)++, x)

#define CLEAR_FIRST_TOK(x)      (x->_val_len = 0, x)
#define CLEAR_LAST_TOK(x)       (x->_last->_val_len = 0, x)

#define CORRECT_VAL(x, str)     (x->_val     = str,                          \
			         x->_val_len = sizeof(str) - 2,              \
			         x)

#define ALLOC_TOKEN(c, s)       (BR_lex_alloc_token(c, s, sizeof(s) - 2))

#define SET_ACCESS(bits)    (CLEAR_BITS(default_token->_bits, ACCESS_BITS),  \
			     SET_BITS(default_token->_bits, bits),           \
			     CLEAR_BITS(default_token->_val_len,ACCESS_BITS),\
			     SET_BITS(default_token->_val_len, bits))

#define CLEAR_TEMPLATE()        \
  if (template_args != BR_Null)                                              \
  {                                                                          \
    template_args = BR_Null;                                                 \
    default_token = BR_lex_unstack_frame();                                  \
  }                                                                          \
  template_flag = BR_FALSE;                                                  \
  BR_lex_empty_frame();


   /*-----------------------------------------------------------------------*/

static
FCT (void, BR_replace_template_args, (BR_TokenPt token) );

static
FCT (void, BR_format_SU, (BR_TokenPt SU_tree, BR_ULong default_info) );


   /*-----------------------------------------------------------------------*/

#line 440 "BR_Parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "BR_Parser.tab.h".  */
#ifndef YY_BR_YY_BR_PARSER_TAB_H_INCLUDED
# define YY_BR_YY_BR_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int BR_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_ARRAY = 258,
    T_PREFIX = 259,
    T_ELLIPSIS = 260,
    T_OPERATOR = 261,
    T_STRUCT = 262,
    T_UNION = 263,
    T_CLASS = 264,
    T_ENUM = 265,
    T_NAMESPACE = 266,
    T_USING = 267,
    T_PUBLIC = 268,
    T_PROTECTED = 269,
    T_PRIVATE = 270,
    T_IDENT = 271,
    T_TEMPLATE = 272,
    T_BASIC = 273,
    T_TEMPLATE_ARG = 274,
    T_FRAME = 275,
    T_CONST = 276,
    T_FRIEND = 277,
    T_LEXER_ERROR = 278
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE BR_yylval;

int BR_yyparse (void);

#endif /* !YY_BR_YY_BR_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 515 "BR_Parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   776

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  47
/* YYNRULES -- Number of rules.  */
#define YYNRULES  176
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  297

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   278

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     2,
       6,    33,     3,     2,    34,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    31,    27,
       2,    30,    32,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    28,     2,    29,    35,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     5,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   387,   387,   388,   391,   394,   396,   399,   401,   404,
     407,   409,   412,   417,   423,   425,   427,   429,   431,   439,
     440,   441,   442,   449,   451,   453,   455,   464,   464,   484,
     489,   500,   505,   517,   518,   520,   528,   530,   530,   532,
     532,   540,   541,   542,   543,   544,   545,   551,   556,   568,
     570,   578,   580,   588,   593,   598,   609,   611,   619,   621,
     628,   632,   639,   652,   654,   667,   669,   671,   678,   680,
     682,   689,   691,   693,   706,   714,   722,   730,   735,   739,
     747,   755,   763,   768,   772,   781,   790,   799,   805,   813,
     824,   826,   833,   840,   845,   847,   854,   861,   872,   874,
     881,   883,   897,   899,   901,   903,   905,   912,   918,   929,
     935,   948,   950,   952,   954,   956,   960,   968,   970,   977,
     990,   992,   994,  1002,  1007,  1010,  1009,  1019,  1030,  1037,
    1036,  1050,  1056,  1062,  1068,  1074,  1080,  1093,  1092,  1102,
    1107,  1114,  1126,  1138,  1143,  1148,  1153,  1164,  1166,  1168,
    1165,  1171,  1176,  1170,  1184,  1186,  1188,  1189,  1190,  1191,
    1192,  1198,  1200,  1207,  1209,  1217,  1225,  1236,  1247,  1249,
    1251,  1253,  1255,  1258,  1266,  1268,  1270
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'*'", "'&'", "T_ARRAY", "'('",
  "T_PREFIX", "T_ELLIPSIS", "T_OPERATOR", "T_STRUCT", "T_UNION", "T_CLASS",
  "T_ENUM", "T_NAMESPACE", "T_USING", "T_PUBLIC", "T_PROTECTED",
  "T_PRIVATE", "T_IDENT", "T_TEMPLATE", "T_BASIC", "T_TEMPLATE_ARG",
  "T_FRAME", "T_CONST", "T_FRIEND", "T_LEXER_ERROR", "';'", "'{'", "'}'",
  "'='", "':'", "'>'", "')'", "','", "'~'", "$accept", "SU_List",
  "Decl_Def", "Code_Def", "Extern_Block", "$@1", "Prefix", "Qualified",
  "Init", "Code", "$@2", "$@3", "C_Arg_Specifier", "Template",
  "Template_List", "Bit_Specifier", "Agg_Specifier", "Basic",
  "Full_Arg_List", "Arg_List", "Arg", "ADeclarator",
  "TDeclarator_Bit_List", "TDeclarator_List", "TDeclarator",
  "Operator_Decl", "Operator_Basic", "Aggregate", "$@4", "Aggregate_Head",
  "$@5", "Aggregate_Name", "Namespace", "$@6", "Namespace_Head",
  "Namespace_Name", "Parent_List", "ESU_List", "$@7", "$@8", "$@9", "$@10",
  "Friend_Decl", "Full_FDeclarator", "FDeclarator_List", "FDeclarator",
  "Access", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    42,    38,   258,    40,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    59,   123,   125,
      61,    58,    62,    41,    44,   126
};
# endif

#define YYPACT_NINF -192

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-192)))

#define YYTABLE_NINF -154

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -192,   351,  -192,   222,    59,    59,    59,   529,   -11,    17,
      48,     2,    60,    47,    80,   185,  -192,  -192,  -192,   105,
      71,  -192,  -192,   102,    99,    86,   425,   116,   158,   127,
      26,   353,   239,    10,   123,  -192,   113,  -192,  -192,   128,
     280,   314,   280,   314,   280,    23,   141,   144,   147,   153,
     168,  -192,  -192,  -192,   198,   328,    45,    79,   122,   200,
     202,  -192,   176,  -192,  -192,  -192,   246,   198,  -192,  -192,
      59,   529,   237,   232,  -192,    31,   234,  -192,   204,  -192,
    -192,   230,   353,   320,   240,  -192,    14,   405,   210,   682,
     230,   353,  -192,   150,   241,   353,  -192,  -192,   167,  -192,
     525,   250,  -192,  -192,   252,   755,  -192,  -192,   241,   191,
    -192,   253,   256,  -192,   264,  -192,  -192,  -192,  -192,  -192,
    -192,  -192,  -192,  -192,   269,  -192,   277,  -192,  -192,  -192,
     619,   280,   314,   198,  -192,   198,   273,  -192,   323,   334,
     334,   166,   286,   304,  -192,  -192,  -192,   340,  -192,  -192,
    -192,  -192,  -192,    59,  -192,  -192,  -192,   224,   191,   334,
    -192,   293,  -192,  -192,  -192,  -192,  -192,   349,   127,  -192,
     292,   358,  -192,  -192,  -192,  -192,  -192,  -192,  -192,   334,
     334,  -192,   453,   189,   362,  -192,   385,  -192,   362,  -192,
     385,   362,   385,   352,  -192,   743,  -192,  -192,  -192,   150,
     191,  -192,  -192,  -192,   366,   368,   484,   255,  -192,  -192,
    -192,  -192,   387,   292,   652,   362,   385,   362,   385,   370,
      42,   334,  -192,  -192,  -192,  -192,  -192,   377,   286,  -192,
    -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,   387,  -192,
    -192,  -192,  -192,   362,   385,  -192,  -192,   729,   381,  -192,
     740,   740,   740,   529,   124,   707,   740,   718,   740,  -192,
    -192,    66,   140,  -192,   198,   394,   394,   126,   198,   740,
     529,   686,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,
    -192,   740,  -192,   384,  -192,  -192,  -192,  -192,   394,   198,
     334,   553,   394,  -192,   586,  -192,  -192
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,   132,   133,
     131,     0,     0,     0,    31,     0,    56,     3,    93,     0,
       0,     7,    14,     0,     0,    33,     0,     0,     0,    52,
       0,    39,     0,     0,   128,     9,     0,   141,    17,     0,
     102,   111,   103,   112,     0,     0,     0,     0,     0,     0,
       0,   120,   121,   122,     0,   117,    54,    55,    53,    51,
       0,   142,     0,    29,    49,    47,     0,     0,     5,     2,
       0,     0,    32,     0,   105,     0,    34,    91,    33,    90,
     106,    19,    39,     0,     0,     8,     0,     0,    39,     0,
      20,    39,    12,    33,    21,    39,    57,     4,     0,   114,
       0,     0,    92,    23,     0,     0,   115,    10,    22,    33,
     127,     0,     0,   139,     0,    18,   116,    54,    55,    53,
      51,   108,   118,   119,     0,   123,     0,    50,    48,   107,
       0,   104,   113,     0,    30,     0,     0,    58,    67,    65,
      66,     0,    33,     0,    91,    24,    15,     0,     6,    13,
      11,    25,    98,     0,    99,    26,    97,    33,    33,    67,
      36,     0,    44,    45,    43,    42,    46,     0,    41,     2,
       0,   130,     2,   124,   140,    28,   110,   109,    60,    74,
      75,    78,     0,     0,    73,    77,    70,    78,    71,    77,
      68,    72,    69,     0,    59,     0,    63,    35,    16,    33,
      33,    95,    94,    96,     0,     0,     0,     0,   176,   175,
     174,   143,     0,     0,     0,    79,    84,    80,    85,    67,
       0,    76,    83,    82,    88,    87,    62,     0,    33,   100,
     101,    38,    40,   148,   126,   151,   144,   145,     0,   138,
      78,    77,    89,    81,    86,    61,    64,     0,     0,   146,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   149,
     156,     0,   163,   152,     0,   168,   169,     0,     0,     0,
       0,     0,   154,   165,   157,   158,   155,   159,   160,     2,
     162,     0,   171,     0,   172,     2,   173,   166,   170,     0,
      67,     0,   164,   161,     0,   167,    77
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -192,   -60,   389,   391,  -192,  -192,    44,    -1,    33,   145,
    -192,  -192,  -192,  -192,  -192,    65,     6,   313,   263,  -192,
     226,  -125,   -15,   -30,   318,   -64,  -192,   -25,  -192,  -192,
    -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,  -192,
    -192,  -192,  -192,   212,  -192,  -168,  -191
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    20,    21,    22,    23,    24,   264,   102,   103,
     104,   105,   167,    26,    66,    27,    28,    29,   106,   141,
     142,   186,    30,    94,    31,    54,    55,    32,   111,    33,
     112,    34,    35,   114,    36,    37,   171,   207,   247,   279,
     248,   285,   259,   260,   261,   262,   212
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      25,    89,   108,    40,    42,    44,    51,   133,    56,   130,
      81,   110,    90,    53,   190,   192,   235,     4,     5,    74,
      75,    59,   238,     7,    78,    86,    78,    93,    99,   100,
      60,    93,    87,    14,     4,     5,    57,     6,  -125,   136,
       7,    46,    47,    48,    49,    18,  -135,   224,   100,    19,
      14,    50,    16,    97,   216,   218,   116,   220,    79,   108,
      98,    62,     4,     5,   137,     6,    19,    58,     7,   131,
      51,    81,    52,  -135,   138,   242,  -135,    53,    14,    61,
    -136,   140,   265,   266,   267,    78,    93,    63,    93,     4,
       5,    74,    75,   280,    19,     7,   244,   157,    68,   159,
     281,   288,    70,   267,   166,    14,   140,  -136,    71,   206,
    -136,    79,   214,   292,   113,    50,    76,    77,    72,     4,
       5,    19,     6,  -134,    67,     7,   152,   269,   154,    25,
      69,   282,   100,   270,    73,    14,    52,   184,   188,   191,
     139,  -137,   154,    72,    50,   282,   100,    18,    96,    50,
    -134,    19,   199,  -134,  -129,    74,   100,   115,   184,   286,
     117,     4,     5,   118,     6,   139,   119,     7,   283,   211,
       4,     5,   120,     6,   193,   196,     7,    14,   215,   217,
      76,   219,   183,   183,   183,    92,    14,    72,   140,   268,
     202,   203,   221,    19,   159,   126,    99,   100,   156,   194,
     195,   140,    19,   183,   100,    25,   289,    64,    72,    74,
     100,   236,   237,    25,    50,    99,   100,    65,   184,   291,
     243,    76,   258,   183,   183,   294,   183,   145,   124,    74,
     100,   125,   229,   230,    76,   144,   151,   249,   101,    50,
     155,   -37,     4,     5,   134,     6,   255,   139,     7,    38,
      39,   135,    51,   257,    76,   201,    50,    50,    14,    53,
     139,   246,   143,   183,    98,   183,   107,   148,   127,    51,
     290,   208,   209,   210,    19,   153,    53,   140,   128,   160,
     233,   169,    50,   161,   234,    74,   100,   170,    80,   184,
      25,   254,   172,    25,   254,   254,   254,    50,   173,   254,
     254,   254,   254,    80,   174,    80,   178,    80,   208,   209,
     210,    14,   256,   254,    50,   254,    76,   121,    52,    99,
     100,   204,    41,    43,    45,   254,   179,   180,   181,   182,
     129,   122,   123,   197,   183,    52,   139,   179,   180,   187,
     182,    80,    14,    82,    88,    91,    95,   146,   147,    80,
     109,     2,     3,    14,     4,     5,    80,     6,    99,   100,
       7,     8,     9,    10,    11,    12,    13,   222,   100,   198,
      14,    15,    16,   179,   180,   240,   182,   205,    17,   -27,
     -33,   101,    18,    76,   -37,   226,    19,   -33,   132,    14,
     224,   100,   213,    45,    80,   231,   176,   232,   177,   282,
     100,   185,   189,   189,    82,    95,    14,   109,     4,     5,
     245,     6,   263,   293,     7,    84,   158,    85,   168,     0,
      80,   228,   189,     0,    14,     0,    83,     0,     4,     5,
       0,     6,   149,     0,     7,     8,     9,    10,    11,     0,
      19,     0,   189,   189,    14,   189,    16,   223,     0,   225,
       0,   223,     0,   225,   223,   225,   179,   180,   187,   182,
      19,   136,    80,    46,    47,    48,    49,   274,   275,   277,
     278,   200,    14,     0,    16,     0,     0,     0,   223,   225,
     223,   225,   241,   225,   189,     3,   137,     4,     5,     0,
       6,     0,     0,     7,     8,     9,    10,    11,    12,    13,
    -147,  -147,  -147,    14,    15,    16,   223,   225,     0,  -147,
       0,    17,   -27,  -147,     0,    18,     0,     0,   273,    19,
       0,     0,     0,     0,     0,   284,     0,   273,   284,   284,
     284,   287,     0,   136,     0,    46,    47,    48,    49,    46,
      47,    48,    49,     0,    14,     0,    16,     0,    14,     0,
      16,   284,   295,   296,     3,   284,     4,     5,   137,     6,
       0,     0,     7,     8,     9,    10,    11,    12,    13,  -150,
    -150,  -150,    14,    15,    16,     0,     0,     0,  -150,     0,
      17,   -27,  -150,     0,    18,     0,     0,     3,    19,     4,
       5,     0,     6,     0,     0,     7,     8,     9,    10,    11,
      12,    13,  -153,  -153,  -153,    14,    15,    16,     0,     0,
       0,  -153,     0,    17,   -27,  -153,     0,    18,     0,     0,
       3,    19,     4,     5,     0,     6,     0,     0,     7,     8,
       9,    10,    11,    12,    13,     0,     0,     0,    14,    15,
      16,     0,     0,     0,     0,     0,    17,   -27,   175,     0,
      18,     0,     0,     3,    19,     4,     5,     0,     6,     0,
       0,     7,     8,     9,    10,    11,    12,    13,     0,     0,
       0,    14,    15,    16,     0,     0,     0,     0,     0,    17,
     -27,   239,     0,    18,     0,     4,     5,    19,     6,   250,
     251,     7,   252,     0,   136,   253,    46,    47,    48,    49,
       0,    14,     0,     0,     0,    14,     0,    16,     0,   150,
     250,   251,     0,   271,     0,     0,   253,    19,     0,   137,
       0,   250,   251,     0,   252,     0,    14,   253,     0,     0,
       0,     0,   250,   251,   272,   252,     0,    14,   253,     8,
       9,    10,    11,   250,   251,   276,   252,     0,    14,   253,
      16,   227,     0,    46,    47,    48,    49,     0,     0,    14,
       0,     0,    14,     0,    16,   162,   163,   164,   165,     0,
       0,     0,     0,     0,    14,     0,    16
};

static const yytype_int16 yycheck[] =
{
       1,    26,    32,     4,     5,     6,     7,    71,    19,    69,
      25,     1,    27,     7,   139,   140,   207,     3,     4,     5,
       6,    19,   213,     9,    25,    26,    27,    28,     5,     6,
      28,    32,    26,    19,     3,     4,    19,     6,    28,     8,
       9,    10,    11,    12,    13,    31,     1,     5,     6,    35,
      19,     7,    21,    27,   179,   180,    33,   182,    25,    89,
      34,    14,     3,     4,    33,     6,    35,    19,     9,    70,
      71,    86,     7,    28,    75,    33,    31,    71,    19,    19,
       1,    75,   250,   251,   252,    86,    87,     7,    89,     3,
       4,     5,     6,    27,    35,     9,   221,    98,    27,   100,
      34,   269,     3,   271,   105,    19,   100,    28,     9,   169,
      31,    78,   172,   281,     1,    71,    30,    31,    19,     3,
       4,    35,     6,     1,    19,     9,    93,     3,    95,   130,
      28,     5,     6,     9,    35,    19,    71,   138,   139,   140,
      75,    28,   109,    19,   100,     5,     6,    31,    21,   105,
      28,    35,   153,    31,    31,     5,     6,    29,   159,    33,
      19,     3,     4,    19,     6,   100,    19,     9,    28,   170,
       3,     4,    19,     6,     8,   142,     9,    19,   179,   180,
      30,   182,   138,   139,   140,    27,    19,    19,   182,   253,
     157,   158,     3,    35,   195,    19,     5,     6,    31,    33,
      34,   195,    35,   159,     6,   206,   270,    22,    19,     5,
       6,   212,   213,   214,   170,     5,     6,    32,   219,   279,
     221,    30,   247,   179,   180,   285,   182,    82,    28,     5,
       6,    29,   199,   200,    30,    31,    91,   238,    28,   195,
      95,    31,     3,     4,     7,     6,   247,   182,     9,    27,
      28,    19,   253,   247,    30,    31,   212,   213,    19,   253,
     195,   228,    28,   219,    34,   221,    27,    27,    22,   270,
     271,    16,    17,    18,    35,    34,   270,   271,    32,    29,
      25,    28,   238,    31,    29,     5,     6,    31,    25,   290,
     291,   247,    28,   294,   250,   251,   252,   253,    29,   255,
     256,   257,   258,    40,    27,    42,    33,    44,    16,    17,
      18,    19,   247,   269,   270,   271,    30,    54,   253,     5,
       6,    28,     4,     5,     6,   281,     3,     4,     5,     6,
      67,     3,     4,    29,   290,   270,   271,     3,     4,     5,
       6,    78,    19,    25,    26,    27,    28,    27,    28,    86,
      32,     0,     1,    19,     3,     4,    93,     6,     5,     6,
       9,    10,    11,    12,    13,    14,    15,     5,     6,    29,
      19,    20,    21,     3,     4,     5,     6,    28,    27,    28,
      27,    28,    31,    30,    31,    33,    35,    34,    70,    19,
       5,     6,    34,    75,   131,    29,   133,    29,   135,     5,
       6,   138,   139,   140,    86,    87,    19,    89,     3,     4,
      33,     6,    31,    29,     9,    26,    98,    26,   105,    -1,
     157,   195,   159,    -1,    19,    -1,     1,    -1,     3,     4,
      -1,     6,    27,    -1,     9,    10,    11,    12,    13,    -1,
      35,    -1,   179,   180,    19,   182,    21,   184,    -1,   186,
      -1,   188,    -1,   190,   191,   192,     3,     4,     5,     6,
      35,     8,   199,    10,    11,    12,    13,   255,   256,   257,
     258,   153,    19,    -1,    21,    -1,    -1,    -1,   215,   216,
     217,   218,   219,   220,   221,     1,    33,     3,     4,    -1,
       6,    -1,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,   243,   244,    -1,    25,
      -1,    27,    28,    29,    -1,    31,    -1,    -1,   255,    35,
      -1,    -1,    -1,    -1,    -1,   262,    -1,   264,   265,   266,
     267,   268,    -1,     8,    -1,    10,    11,    12,    13,    10,
      11,    12,    13,    -1,    19,    -1,    21,    -1,    19,    -1,
      21,   288,   289,   290,     1,   292,     3,     4,    33,     6,
      -1,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    25,    -1,
      27,    28,    29,    -1,    31,    -1,    -1,     1,    35,     3,
       4,    -1,     6,    -1,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    -1,
      -1,    25,    -1,    27,    28,    29,    -1,    31,    -1,    -1,
       1,    35,     3,     4,    -1,     6,    -1,    -1,     9,    10,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    19,    20,
      21,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,    -1,
      31,    -1,    -1,     1,    35,     3,     4,    -1,     6,    -1,
      -1,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,    27,
      28,    29,    -1,    31,    -1,     3,     4,    35,     6,     3,
       4,     9,     6,    -1,     8,     9,    10,    11,    12,    13,
      -1,    19,    -1,    -1,    -1,    19,    -1,    21,    -1,    27,
       3,     4,    -1,     6,    -1,    -1,     9,    35,    -1,    33,
      -1,     3,     4,    -1,     6,    -1,    19,     9,    -1,    -1,
      -1,    -1,     3,     4,    27,     6,    -1,    19,     9,    10,
      11,    12,    13,     3,     4,    27,     6,    -1,    19,     9,
      21,     8,    -1,    10,    11,    12,    13,    -1,    -1,    19,
      -1,    -1,    19,    -1,    21,    10,    11,    12,    13,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    21
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    37,     0,     1,     3,     4,     6,     9,    10,    11,
      12,    13,    14,    15,    19,    20,    21,    27,    31,    35,
      38,    39,    40,    41,    42,    43,    49,    51,    52,    53,
      58,    60,    63,    65,    67,    68,    70,    71,    27,    28,
      43,    60,    43,    60,    43,    60,    10,    11,    12,    13,
      42,    43,    51,    52,    61,    62,    19,    19,    19,    19,
      28,    19,    14,     7,    22,    32,    50,    19,    27,    28,
       3,     9,    19,    35,     5,     6,    30,    31,    43,    44,
      54,    58,    60,     1,    38,    39,    43,    52,    60,    63,
      58,    60,    27,    43,    59,    60,    21,    27,    34,     5,
       6,    28,    44,    45,    46,    47,    54,    27,    59,    60,
       1,    64,    66,     1,    69,    29,    33,    19,    19,    19,
      19,    54,     3,     4,    28,    29,    19,    22,    32,    54,
      37,    43,    60,    61,     7,    19,     8,    33,    43,    51,
      52,    55,    56,    28,    31,    45,    27,    28,    27,    27,
      27,    45,    44,    34,    44,    45,    31,    43,    60,    43,
      29,    31,    10,    11,    12,    13,    43,    48,    53,    28,
      31,    72,    28,    29,    27,    29,    54,    54,    33,     3,
       4,     5,     6,    42,    43,    54,    57,     5,    43,    54,
      57,    43,    57,     8,    33,    34,    44,    29,    29,    43,
      60,    31,    44,    44,    28,    28,    37,    73,    16,    17,
      18,    43,    82,    34,    37,    43,    57,    43,    57,    43,
      57,     3,     5,    54,     5,    54,    33,     8,    56,    44,
      44,    29,    29,    25,    29,    82,    43,    43,    82,    29,
       5,    54,    33,    43,    57,    33,    44,    74,    76,    43,
       3,     4,     6,     9,    42,    43,    51,    52,    63,    78,
      79,    80,    81,    31,    43,    81,    81,    81,    61,     3,
       9,     6,    27,    54,    79,    79,    27,    79,    79,    75,
      27,    34,     5,    28,    54,    77,    33,    54,    81,    61,
      43,    37,    81,    29,    37,    54,    54
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    36,    37,    37,    37,    37,    37,    37,    37,    37,
      37,    37,    37,    37,    37,    37,    37,    37,    37,    38,
      38,    38,    38,    39,    39,    39,    39,    41,    40,    42,
      42,    43,    43,    44,    44,    44,    45,    46,    45,    47,
      45,    48,    48,    48,    48,    48,    48,    49,    49,    50,
      50,    51,    51,    52,    52,    52,    53,    53,    54,    54,
      54,    54,    54,    55,    55,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      58,    58,    58,    58,    58,    58,    58,    58,    59,    59,
      59,    59,    60,    60,    60,    60,    60,    60,    60,    60,
      60,    60,    60,    60,    60,    60,    60,    61,    61,    61,
      62,    62,    62,    63,    63,    64,    63,    63,    65,    66,
      65,    67,    67,    67,    67,    67,    67,    69,    68,    68,
      68,    70,    71,    72,    72,    72,    72,    73,    74,    75,
      73,    76,    77,    73,    78,    78,    78,    78,    78,    78,
      78,    79,    79,    80,    80,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    82,    82,    82
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     4,     2,     3,     2,
       3,     4,     3,     4,     2,     4,     5,     3,     4,     2,
       2,     2,     2,     2,     3,     3,     3,     0,     4,     2,
       3,     1,     2,     0,     1,     3,     2,     0,     4,     0,
       4,     1,     1,     1,     1,     1,     1,     2,     3,     1,
       2,     2,     1,     2,     2,     2,     1,     2,     2,     3,
       3,     5,     4,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     1,     1,     2,
       2,     3,     2,     2,     2,     2,     3,     2,     2,     3,
       2,     2,     2,     1,     4,     4,     4,     3,     2,     2,
       4,     4,     2,     2,     3,     2,     2,     3,     3,     4,
       4,     2,     2,     3,     2,     2,     3,     1,     2,     2,
       1,     1,     1,     3,     4,     0,     5,     2,     1,     0,
       3,     1,     1,     1,     2,     2,     2,     0,     5,     2,
       4,     1,     2,     2,     3,     3,     4,     1,     0,     0,
       6,     0,     0,     6,     2,     2,     1,     2,     2,     2,
       2,     3,     2,     1,     3,     2,     3,     4,     2,     2,
       3,     2,     2,     3,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 387 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_save_state(); }
#line 1899 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 389 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 1905 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 392 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 1911 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 395 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 1917 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 397 "BR_Parser.y" /* yacc.c:1646  */
    { CLEAR_TEMPLATE(); }
#line 1923 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 400 "BR_Parser.y" /* yacc.c:1646  */
    {  BR_lex_empty_frame(); }
#line 1929 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 402 "BR_Parser.y" /* yacc.c:1646  */
    { CLEAR_TEMPLATE(); }
#line 1935 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 405 "BR_Parser.y" /* yacc.c:1646  */
    {  BR_lex_empty_frame(); }
#line 1941 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 408 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 1947 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 410 "BR_Parser.y" /* yacc.c:1646  */
    { CLEAR_TEMPLATE(); }
#line 1953 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 413 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[-1])->_bits));
          BR_lex_empty_frame();
        }
#line 1962 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 418 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[-1])->_bits));
          CLEAR_TEMPLATE();
        }
#line 1971 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 426 "BR_Parser.y" /* yacc.c:1646  */
    { CLEAR_TEMPLATE();     BR_lex_synchronize(); }
#line 1977 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 428 "BR_Parser.y" /* yacc.c:1646  */
    { CLEAR_TEMPLATE();     BR_lex_synchronize(); }
#line 1983 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 430 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); BR_lex_synchronize(); }
#line 1989 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 432 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); BR_lex_synchronize(); }
#line 1995 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 450 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[0])->_bits)); }
#line 2001 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 452 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[0])->_bits)); }
#line 2007 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 454 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[0])->_bits)); }
#line 2013 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 456 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), (default_token->_bits | (yyvsp[0])->_bits)); }
#line 2019 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 464 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (TEST_BITS(default_token->_bits, BR_INFO_EXTERN))
          {
	    default_token = BR_lex_stack_frame(BR_INFO_EXTERN);
	    BR_lex_jump_bracket();
	  }
          else
            BR_YYERROR;
        }
#line 2033 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 474 "BR_Parser.y" /* yacc.c:1646  */
    {
          default_token = BR_lex_unstack_frame();
          CLEAR_BITS(default_token->_bits, BR_INFO_EXTERN);
        }
#line 2042 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 485 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-1])->_line_num = prefix_stamp++;
	  (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0]));
        }
#line 2051 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 490 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-1])->_line_num = (yyvsp[-2])->_line_num;
          (yyval) = APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0]));
        }
#line 2060 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 501 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[0])->_prefix = BR_Null;
          (yyval) = (yyvsp[0]);
	}
#line 2069 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 506 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[0])->_prefix = (yyvsp[-1]);
          (yyval) = (yyvsp[0]);
        }
#line 2078 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 517 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = BR_Null; }
#line 2084 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 519 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = &tmp_token; }
#line 2090 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 521 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = &tmp_token; }
#line 2096 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 529 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = &tmp_token; (yyval)->_bits = (BR_INFO_PROC | BR_INFO_DEF); }
#line 2102 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 530 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_ignore_proc_tail(); }
#line 2108 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 531 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = &tmp_token; (yyval)->_bits = (BR_INFO_PROC | BR_INFO_DEF); }
#line 2114 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 532 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_ignore_proc_tail(); }
#line 2120 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 533 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = &tmp_token; (yyval)->_bits = (BR_INFO_PROC | BR_INFO_DEF | BR_INFO_C); }
#line 2126 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 552 "BR_Parser.y" /* yacc.c:1646  */
    {
          template_flag = BR_TRUE;
          template_args = BR_Null;
        }
#line 2135 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 557 "BR_Parser.y" /* yacc.c:1646  */
    { 
          template_flag = BR_TRUE;
          template_args = (yyvsp[-1]);
          default_token = BR_lex_stack_frame(BR_INFO_EMPTY);
        }
#line 2145 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 569 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2151 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 571 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0])); }
#line 2157 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 579 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2163 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 581 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = CONVERT_BASIC((yyvsp[0])); }
#line 2169 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 589 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          (yyval)->_bits = BR_INFO_CLASS;
        }
#line 2178 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 594 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          (yyval)->_bits = BR_INFO_STRUCT;
        }
#line 2187 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 599 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          (yyval)->_bits = BR_INFO_UNION;
        }
#line 2196 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 610 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2202 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 612 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); SET_BITS((yyval)->_bits, (yyvsp[0])->_bits); }
#line 2208 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 620 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0])); }
#line 2214 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 622 "BR_Parser.y" /* yacc.c:1646  */
    { 
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4((yyvsp[-2]), SPACE(alloc_token), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0])));
        }
#line 2225 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 629 "BR_Parser.y" /* yacc.c:1646  */
    { 
          (yyval) = APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0]));
        }
#line 2233 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 633 "BR_Parser.y" /* yacc.c:1646  */
    { 
          (yyval) = ((TEST_BITS((yyvsp[-4])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND5((yyvsp[-4]), SPACE(alloc_token), SPACE((yyvsp[-3])), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND4((yyvsp[-4]), SPACE((yyvsp[-3])), (yyvsp[-1]), (yyvsp[0])));
        }
#line 2244 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 640 "BR_Parser.y" /* yacc.c:1646  */
    { 
          (yyval) = ((TEST_BITS((yyvsp[-3])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND5((yyvsp[-3]), SPACE(alloc_token), SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND4((yyvsp[-3]), SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])));
        }
#line 2255 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 653 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2261 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 655 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4((yyvsp[-3]), SPACE((yyvsp[-2])), SPACE(alloc_token), (yyvsp[-1])))
		  : APPEND3((yyvsp[-3]), SPACE((yyvsp[-2])), (yyvsp[-1])));
        }
#line 2272 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 668 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2278 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 670 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2284 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 672 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (template_args != BR_Null)
            BR_replace_template_args((yyvsp[0]));
          (yyval) = (yyvsp[0]);
        }
#line 2294 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 679 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = APPEND2(SPACE((yyvsp[-1])), (yyvsp[0])); }
#line 2300 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 681 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = APPEND2(SPACE((yyvsp[-1])), (yyvsp[0])); }
#line 2306 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 683 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (template_args != BR_Null)
            BR_replace_template_args((yyvsp[-1]));
          (yyval) = APPEND2(SPACE((yyvsp[-1])), (yyvsp[0]));
        }
#line 2316 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 690 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2322 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 692 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2328 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 694 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (template_args != BR_Null)
            BR_replace_template_args((yyvsp[-1]));
          (yyval) = (yyvsp[-1]);
        }
#line 2338 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 707 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[0])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND2(SPACE((yyvsp[0])), alloc_token))
		  : (yyvsp[0]));
          SET_PRECED((yyval), S_PRECED);
        }
#line 2350 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 715 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[0])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND2(SPACE((yyvsp[0])), alloc_token))
		  : (yyvsp[0]));
          SET_PRECED((yyval), A_PRECED);
        }
#line 2362 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 723 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[-1])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3((yyvsp[-1]), SPACE((yyvsp[0])), alloc_token))
		  : APPEND2((yyvsp[-1]), (yyvsp[0])));
          SET_PRECED((yyval), P_PRECED);
        }
#line 2374 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 731 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = CORRECT_VAL((yyvsp[0]), STR_FCT_PT);
          SET_PRECED((yyval), F_PRECED);
        }
#line 2383 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 736 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); SET_PRECED((yyval), T_PRECED); }
#line 2389 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 740 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[-1])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND2(SPACE((yyvsp[-1])), alloc_token))
		  : (yyvsp[-1]));
          SET_PRECED((yyval), S_PRECED);
        }
#line 2401 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 748 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[-1])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND2(SPACE((yyvsp[-1])), alloc_token))
		  : (yyvsp[-1]));
          SET_PRECED((yyval), A_PRECED);
        }
#line 2413 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 756 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3((yyvsp[-2]), SPACE((yyvsp[-1])), alloc_token))
		  : APPEND2((yyvsp[-2]), (yyvsp[-1])));
          SET_PRECED((yyval), P_PRECED);
        }
#line 2425 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 764 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = CORRECT_VAL((yyvsp[0]), STR_FCT_PT);
          SET_PRECED((yyval), F_PRECED);
        }
#line 2434 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 769 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); SET_PRECED((yyval), T_PRECED); }
#line 2440 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 773 "BR_Parser.y" /* yacc.c:1646  */
    {
          TEST_PRECED((yyvsp[0]), S_PRECED);
          (yyval) = ((TEST_BITS((yyvsp[-1])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3(SPACE((yyvsp[-1])), SPACE(alloc_token), (yyvsp[0])))
		  : APPEND2((yyvsp[-1]), (yyvsp[0])));
          SET_PRECED((yyval), S_PRECED);
        }
#line 2453 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 782 "BR_Parser.y" /* yacc.c:1646  */
    {
          TEST_PRECED((yyvsp[0]), A_PRECED);
          (yyval) = ((TEST_BITS((yyvsp[-1])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3(SPACE((yyvsp[-1])), SPACE(alloc_token), (yyvsp[0])))
		  : APPEND2((yyvsp[-1]), (yyvsp[0])));
          SET_PRECED((yyval), A_PRECED);
        }
#line 2466 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 791 "BR_Parser.y" /* yacc.c:1646  */
    {
          TEST_PRECED((yyvsp[0]), P_PRECED);
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4((yyvsp[-2]), SPACE((yyvsp[-1])), SPACE(alloc_token), (yyvsp[0])))
		  : APPEND3((yyvsp[-2]), SPACE((yyvsp[-1])), (yyvsp[0])));
          SET_PRECED((yyval), P_PRECED);
        }
#line 2479 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 800 "BR_Parser.y" /* yacc.c:1646  */
    {
          TEST_PRECED((yyvsp[-1]), F_PRECED);
          (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0]));
          SET_PRECED((yyval), F_PRECED);
        }
#line 2489 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 806 "BR_Parser.y" /* yacc.c:1646  */
    {
          TEST_PRECED((yyvsp[-1]), T_PRECED);
          (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0]));
          SET_PRECED((yyval), T_PRECED);
        }
#line 2499 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 814 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0]));
          SET_PRECED((yyval), GET_PRECED((yyvsp[-1])));
        }
#line 2508 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 825 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA); }
#line 2514 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 827 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (global_prefix != BR_Null)         
            BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA);
          else
            BR_YYERROR;
        }
#line 2525 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 834 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (((yyvsp[0]) != BR_Null) && (((yyvsp[-1])->_bits & BR_INFO_PROC) != 0))
            BR_format_SU((yyvsp[-1]), (default_token->_bits | BR_INFO_PURE));
          else
            BR_format_SU((yyvsp[-1]), default_token->_bits);
        }
#line 2536 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 841 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (global_prefix == BR_Null)
            BR_YYERROR;
        }
#line 2545 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 846 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA); }
#line 2551 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 848 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (global_prefix != BR_Null)         
            BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA);
          else
            BR_YYERROR;
        }
#line 2562 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 855 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (((yyvsp[0]) != BR_Null) && (((yyvsp[-1])->_bits & BR_INFO_PROC) != 0))
            BR_format_SU((yyvsp[-1]), (default_token->_bits | BR_INFO_PURE));
          else
            BR_format_SU((yyvsp[-1]), default_token->_bits);
        }
#line 2573 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 862 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (global_prefix == BR_Null)
            BR_YYERROR;
        }
#line 2582 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 873 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA); }
#line 2588 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 875 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (((yyvsp[0]) != BR_Null) && (((yyvsp[-1])->_bits & BR_INFO_PROC) != 0))
            BR_format_SU((yyvsp[-1]), (default_token->_bits | BR_INFO_PURE));
          else
            BR_format_SU((yyvsp[-1]), default_token->_bits);
        }
#line 2599 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 882 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), default_token->_bits | BR_INFO_DATA); }
#line 2605 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 884 "BR_Parser.y" /* yacc.c:1646  */
    {
          if (((yyvsp[0]) != BR_Null) && (((yyvsp[-1])->_bits & BR_INFO_PROC) != 0))
            BR_format_SU((yyvsp[-1]), (default_token->_bits | BR_INFO_PURE));
          else
            BR_format_SU((yyvsp[-1]), default_token->_bits);
        }
#line 2616 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 898 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_DATA; }
#line 2622 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 900 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_DATA; }
#line 2628 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 902 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_DATA; }
#line 2634 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 904 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); (yyval)->_bits = BR_INFO_DATA; }
#line 2640 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 906 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0]));
          SET_BITS((yyval)->_bits, BR_INFO_PROC);
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, BR_INFO_CONST);
        }
#line 2651 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 913 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = BR_Null;
          (yyval) = APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0]));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_DESTRUCTOR));          
        }
#line 2661 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 919 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = BR_Null;
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4(SPACE((yyvsp[-2])), SPACE(alloc_token), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND3(SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_OPERATOR));
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, BR_INFO_CONST);
        }
#line 2676 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 930 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = (yyvsp[-3]);
          (yyval) = APPEND3((yyvsp[-2]), (yyvsp[-1]), (yyvsp[0]));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_DESTRUCTOR));          
        }
#line 2686 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 936 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = (yyvsp[-3]);
          (yyval) = ((TEST_BITS((yyvsp[-3])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4(SPACE((yyvsp[-2])), SPACE(alloc_token), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND3(SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_OPERATOR));
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, BR_INFO_CONST);
        }
#line 2701 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 949 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2707 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 951 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2713 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 953 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2719 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 955 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2725 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 957 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2731 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 961 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 2737 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 969 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2743 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 971 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[0])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3((yyvsp[-1]), SPACE((yyvsp[0])), alloc_token))
		  : APPEND2((yyvsp[-1]), (yyvsp[0])));
        }
#line 2754 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 978 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ((TEST_BITS((yyvsp[0])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND3((yyvsp[-1]), SPACE((yyvsp[0])), alloc_token))
		  : APPEND2((yyvsp[-1]), (yyvsp[0])));
	}
#line 2765 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 991 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2771 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 993 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2777 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 995 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2783 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1003 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ALLOC_TOKEN(T_IDENT, STR_ANONYMOUS);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_ENUM | default_token->_bits);
	}
#line 2792 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1008 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-2]), BR_INFO_DEF | BR_INFO_ENUM | default_token->_bits); }
#line 2798 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1010 "BR_Parser.y" /* yacc.c:1646  */
    {
          SET_ACCESS((yyvsp[0])->_bits);
          BR_lex_jump_bracket();
        }
#line 2807 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1015 "BR_Parser.y" /* yacc.c:1646  */
    {
          UNSTACK_PREFIX();
          default_token = BR_lex_unstack_frame();
        }
#line 2816 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1020 "BR_Parser.y" /* yacc.c:1646  */
    {
          UNSTACK_PREFIX();
          default_token = BR_lex_unstack_frame();
        }
#line 2825 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1031 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          STACK_PREFIX((yyvsp[0]));
          default_token = BR_lex_stack_frame(BR_INFO_EMPTY);
        }
#line 2835 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1037 "BR_Parser.y" /* yacc.c:1646  */
    {
          STACK_PREFIX((yyvsp[0]));
          default_token = BR_lex_stack_frame(BR_INFO_EMPTY);
          BR_lex_jump_colon();
        }
#line 2845 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1043 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); }
#line 2851 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1051 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ALLOC_TOKEN(T_IDENT, STR_ANONYMOUS);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_CLASS | default_token->_bits);
          (yyval)->_bits = BR_INFO_PRIVATE;
        }
#line 2861 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1057 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ALLOC_TOKEN(T_IDENT, STR_ANONYMOUS);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_STRUCT | default_token->_bits);
          (yyval)->_bits = BR_INFO_PUBLIC;
        }
#line 2871 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1063 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = ALLOC_TOKEN(T_IDENT, STR_ANONYMOUS);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_UNION | default_token->_bits);
          (yyval)->_bits = BR_INFO_PUBLIC;
        }
#line 2881 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1069 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_CLASS | default_token->_bits);
          (yyval)->_bits = BR_INFO_PRIVATE;
        }
#line 2891 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1075 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_STRUCT | default_token->_bits);
          (yyval)->_bits = BR_INFO_PUBLIC;
        }
#line 2901 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1081 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_UNION | default_token->_bits);
          (yyval)->_bits = BR_INFO_PUBLIC;
        }
#line 2911 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1093 "BR_Parser.y" /* yacc.c:1646  */
    {
          SET_ACCESS((yyvsp[0])->_bits);
          BR_lex_jump_bracket();
        }
#line 2920 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1098 "BR_Parser.y" /* yacc.c:1646  */
    {
          UNSTACK_PREFIX();
          default_token = BR_lex_unstack_frame();
        }
#line 2929 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1103 "BR_Parser.y" /* yacc.c:1646  */
    {
          UNSTACK_PREFIX();
          default_token = BR_lex_unstack_frame();
        }
#line 2938 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1115 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          STACK_PREFIX((yyvsp[0]));
          default_token = BR_lex_stack_frame(BR_INFO_EMPTY);
        }
#line 2948 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1127 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = (yyvsp[0]);
          BR_format_SU((yyval), BR_INFO_DEF | BR_INFO_NAMESPACE | default_token->_bits);
          (yyval)->_bits = BR_INFO_NAMESPACE_ELEMENT;
        }
#line 2958 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1139 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[0]), (BR_INFO_PARENT|BR_INFO_PRIVATE|default_token->_bits));
          BR_lex_empty_frame();
        }
#line 2967 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1144 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[0]), (BR_INFO_PARENT|(yyvsp[-1])->_bits|default_token->_bits));
          BR_lex_empty_frame();
        }
#line 2976 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1149 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[0]), (BR_INFO_PARENT|BR_INFO_PRIVATE|default_token->_bits));
          BR_lex_empty_frame();
        }
#line 2985 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1154 "BR_Parser.y" /* yacc.c:1646  */
    {
          BR_format_SU((yyvsp[0]), (BR_INFO_PARENT|(yyvsp[-1])->_bits|default_token->_bits));
          BR_lex_empty_frame();
        }
#line 2994 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1166 "BR_Parser.y" /* yacc.c:1646  */
    { default_token->_bits |= BR_INFO_FRIEND; }
#line 3000 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1168 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 3006 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1171 "BR_Parser.y" /* yacc.c:1646  */
    {
          SET_ACCESS((yyvsp[0])->_bits);
          BR_lex_jump_colon();
        }
#line 3015 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1176 "BR_Parser.y" /* yacc.c:1646  */
    { BR_lex_empty_frame(); }
#line 3021 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1185 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), (default_token->_bits | BR_INFO_TYPEDEF)); }
#line 3027 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1187 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-1]), ((yyvsp[-1])->_bits | default_token->_bits)); }
#line 3033 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1199 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[-2]), ((yyvsp[-2])->_bits | default_token->_bits | BR_INFO_DEF)); }
#line 3039 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1208 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[0]), ((yyvsp[0])->_bits | default_token->_bits)); }
#line 3045 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1210 "BR_Parser.y" /* yacc.c:1646  */
    { BR_format_SU((yyvsp[0]), ((yyvsp[0])->_bits | default_token->_bits)); }
#line 3051 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1218 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyval) = APPEND2((yyvsp[-1]), (yyvsp[0]));
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_CONST));
          else
            SET_BITS((yyval)->_bits, BR_INFO_PROC);
        }
#line 3063 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1226 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = BR_Null;
          (yyval) = ((TEST_BITS((yyvsp[-2])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4(SPACE((yyvsp[-2])), SPACE(alloc_token), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND3(SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_OPERATOR));
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, BR_INFO_CONST);
        }
#line 3078 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1237 "BR_Parser.y" /* yacc.c:1646  */
    {
          (yyvsp[-2])->_prefix = (yyvsp[-3]);
          (yyval) = ((TEST_BITS((yyvsp[-3])->_bits, BR_INFO_CONST))
		  ? (alloc_token = ALLOC_TOKEN(T_CONST, STR_CONST),
		     APPEND4(SPACE((yyvsp[-2])), SPACE(alloc_token), (yyvsp[-1]), (yyvsp[0])))
		  : APPEND3(SPACE((yyvsp[-2])), (yyvsp[-1]), (yyvsp[0])));
          SET_BITS((yyval)->_bits, (BR_INFO_PROC | BR_INFO_OPERATOR));
          if (TEST_BITS((yyvsp[0])->_last->_bits, BR_INFO_CONST))
            SET_BITS((yyval)->_bits, BR_INFO_CONST);
        }
#line 3093 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1248 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 3099 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1250 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 3105 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1252 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 3111 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1254 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 3117 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1256 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 3123 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1259 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 3129 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1267 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_PRIVATE; }
#line 3135 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1269 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_PROTECTED; }
#line 3141 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1271 "BR_Parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval)->_bits = BR_INFO_PUBLIC; }
#line 3147 "BR_Parser.tab.c" /* yacc.c:1646  */
    break;


#line 3151 "BR_Parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1275 "BR_Parser.y" /* yacc.c:1906  */



   /*-----------------------------------------------------------------------*/

#if YYDEBUG != 0

static char val[1024];

static int
BR_yyprint(f, t, v)
     FILE*   f;
     int     t;
     YYSTYPE v;
{
  if ((v != BR_Null) && (v->_val != BR_Null))
  {
    strncpy(val, yylval->_val, (BR_Int) yylval->_val_len + 1);      
    *(val + yylval->_val_len + 1) = '\0';
    fprintf(f, "   [(l=%05ld) \"%s\"]", yylval->_line_num, val);
  }
  return(0);
}

#endif


   /*-----------------------------------------------------------------------*/

int
yyerror(msg)
     char* msg;
{
  if (BR_info_handler != BR_Null)
    BR_info_handler("", "", BR_INFO_ERROR, BR_lex_get_line_num());
  else
    BR_WARNING(">>>>>  Hum, Hum !!! Strange construction at line : %d\n",
	       BR_lex_get_line_num());

  return(0);
}


   /*-----------------------------------------------------------------------*/

#define MAX_TEMPLATE_ARGS   20

static BR_Str* template_substitute[MAX_TEMPLATE_ARGS] =
{
  "$T00 ",
  "$T01 ",
  "$T02 ",
  "$T03 ",
  "$T04 ",
  "$T05 ",
  "$T06 ",
  "$T07 ",
  "$T08 ",
  "$T09 ",

  "$T10 ",
  "$T11 ",
  "$T12 ",
  "$T13 ",
  "$T14 ",
  "$T15 ",
  "$T16 ",
  "$T17 ",
  "$T18 ",
  "$T19 ",
};


static void
BR_replace_template_args(token)
     BR_TokenPt token;
{
  BR_TokenPt curr_arg;
  BR_Int     arg_num;

  curr_arg = template_args;
  arg_num  = 0;
  while (curr_arg != BR_Null)
  {
    if (   (curr_arg->_val_len == token->_val_len)
        && (strncmp(curr_arg->_val, token->_val, token->_val_len) == 0))
    {
      if (arg_num < MAX_TEMPLATE_ARGS)
	token->_val = template_substitute[arg_num];
      else
	token->_val = "$TXX ";
      token->_val_len = 4;
      curr_arg = BR_Null;
    }
    else
      curr_arg = curr_arg->_next;
    arg_num++;
  }
}


   /*-----------------------------------------------------------------------*/

#if YYDEBUG != 0

//static BR_Str dump_buff[1024];
//
//static void
//BR_dump_tree(msg, tree)
//     BR_Str*    msg;
//     BR_TokenPt tree;
//{
//  BR_TokenPt curr_tok;
//
//  fprintf(stderr, "%s\n", msg);
//  curr_tok = tree;
//  while (curr_tok != BR_Null)
//  {
//    strncpy(dump_buff, curr_tok->_val, curr_tok->_val_len);
//    dump_buff[curr_tok->_val_len] = '\0';
//    fprintf(stderr, "   (p=0x%08lx, n=0x%08lx, l=0x%08lx, b=0x%08lx) %s\n",
//	            (BR_ULong) curr_tok,
//	            (BR_ULong) curr_tok->_next,
//	            (BR_ULong) curr_tok->_last,
//	            (BR_ULong) curr_tok->_bits,
//	            dump_buff);
//    curr_tok = curr_tok->_next;
//  }
//}

#endif

  
   /*-----------------------------------------------------------------------*/

static void
BR_format_SU(SU_tree, default_infos)
     BR_TokenPt SU_tree;
     BR_ULong   default_infos;
{
  BR_TokenPt  prev_tok;
  BR_TokenPt  curr_tok;
  BR_Str*     curr_buf;
  BR_Str*     curr_val;
  BR_ULong    infos;
  BR_TokenPt  prefix;
  BR_Str*     str_prefix;
  BR_Str*     str_SU;
  BR_TokenPt  last_token;
  BR_Str*     begin_qualif;
  BR_TokenPt  test_tok;
  BR_TokenPt  last_pref;
  BR_TokenPt  const_token;

  infos = default_infos | SU_tree->_bits;

  /*---------------------------------------------------------  Prefix  --*/
  if ((global_prefix != BR_Null) && (!TEST_BITS(infos, BR_INFO_FRIEND)))
    prefix = global_prefix;
  else
    prefix = SU_tree->_prefix;

  if (prefix != BR_Null)
  {
    if (prefix->_last->_line_num != last_stamp)
    {
      prev_tok = prefix;
      curr_tok = prefix;
      curr_buf = prefix_buffer;
      while (curr_tok != BR_Null)
      {
	curr_val = curr_tok->_val;
	if (curr_tok->_code == T_PREFIX)
        {
	  if (curr_tok->_next != BR_Null)
          {
	    *curr_buf++ = *curr_val++;
	    *curr_buf++ = *curr_val;
	  }
	  else
	    prefix->_last = prev_tok;
	}
	else
        {
	  strncpy(curr_buf, curr_val, curr_tok->_val_len);
	  curr_buf += curr_tok->_val_len;
	}
	prev_tok = curr_tok;
	curr_tok = curr_tok->_next;
      }
      prefix_len  = curr_buf - prefix_buffer;
      *curr_buf++ = '\0';
      last_stamp  = prefix->_last->_line_num;
    }
    str_prefix = prefix_buffer;
  }
  else
    str_prefix = BR_Null;

  /*----------------------------------------------------------  Infos  --*/
  if (TEST_BITS(infos, BR_INFO_PARENT))
  {
    /*fprintf(stderr, ">=> Parent : 0x%08x (0x%08x)\n", infos, CONTROL_PARENT);*/
    if (TEST_BITS(infos, CONTROL_PARENT))
      SET_BITS(infos, BR_INFO_ERROR);    
  }

  if (TEST_BITS(infos, AGGREGATE_BITS))
  {
    CLEAR_BITS(infos, (BR_INFO_EXTERN | BR_INFO_STATIC));
    /*fprintf(stderr,">=> Aggrega : 0x%08x (0x%08x)\n",infos,CONTROL_AGGREGATE);*/
    if (TEST_BITS(infos, CONTROL_AGGREGATE))
      SET_BITS(infos, BR_INFO_ERROR);
    CLEAR_BITS(infos, BR_INFO_TYPEDEF);
    if (TEST_BITS(infos, BR_INFO_FRIEND))
      CLEAR_BITS(infos, ACCESS_BITS);
    else if (template_flag != BR_FALSE)
    {
      if (TEST_BITS(infos, BR_INFO_CLASS))
	SET_BITS(infos, BR_INFO_TEMPLATE);
      else
	SET_BITS(infos, BR_INFO_ERROR);
    }
  }

  if (TEST_BITS(infos, BR_INFO_TYPEDEF))
  {
    /*fprintf(stderr,">=> Typedef : 0x%08x (0x%08x)\n", infos, CONTROL_TYPEDEF);*/
    if (TEST_BITS(infos, CONTROL_TYPEDEF))
      SET_BITS(infos, BR_INFO_ERROR);
    else if (TEST_BITS(infos, BR_INFO_PROC))
      SU_tree->_next = BR_Null;
    CLEAR_BITS(infos, (BR_INFO_PROC | BR_INFO_DATA));
    CLEAR_BITS(infos, (BR_INFO_EXTERN | BR_INFO_STATIC));
    if (TEST_BITS(infos, BR_INFO_FRIEND))
      CLEAR_BITS(infos, ACCESS_BITS);
    else
      SET_BITS(infos, BR_INFO_DEF);
  }

  if (TEST_BITS(infos, BR_INFO_PROC))
  {
    /*fprintf(stderr, ">=> Proc    : 0x%08x (0x%08x)\n", infos, CONTROL_PROC);*/
    if (TEST_BITS(infos, CONTROL_PROC))
      SET_BITS(infos, BR_INFO_ERROR);
    else
    {
      if (TEST_BITS(SU_tree->_last->_bits, BR_INFO_CONST))
      {
        SET_BITS(infos, BR_INFO_CONST);
	const_token = ALLOC_TOKEN(T_CONST, STR_CONST);
	APPEND2(SPACE(SU_tree),const_token);
      }
      if (TEST_BITS(infos, BR_INFO_FRIEND))
      {
        CLEAR_BITS(infos, ACCESS_BITS);
        if (TEST_BITS(infos, CONTROL_FRIEND_PROC))
          SET_BITS(infos, BR_INFO_ERROR);
	else if (TEST_BITS(infos, BR_INFO_DEF))
	  SET_BITS(infos, BR_INFO_INLINE);
      }
      else if (TEST_BITS(infos, BR_INFO_C))
        SU_tree->_next->_next = SU_tree->_last;
      else if (prefix != BR_Null)
      {
        last_pref = prefix->_last;
        if (*(SU_tree->_val) == '~')
          test_tok = SU_tree->_next;
        else
          test_tok = SU_tree;
	if (   (test_tok->_val_len == last_pref->_val_len)
	    && (strncmp(test_tok->_val,
			last_pref->_val,
			last_pref->_val_len) == 0))
        {
	  if (*(SU_tree->_val) != '~')
	    SET_BITS(infos, BR_INFO_CONSTRUCTOR);
        }
	else if (*(SU_tree->_val) == '~')
	  SET_BITS(infos, BR_INFO_ERROR);
	if ((global_prefix != BR_Null) && (TEST_BITS(infos, BR_INFO_DEF)))
	  SET_BITS(infos, BR_INFO_INLINE);
      }
      else if (TEST_BITS(infos, BR_INFO_CONST | BR_INFO_VIRTUAL | BR_INFO_PURE))
        SET_BITS(infos, BR_INFO_ERROR);
      else if (template_flag != BR_FALSE)
        SET_BITS(infos, BR_INFO_TEMPLATE);
      CLEAR_BITS(infos, BR_INFO_EXTERN);
    }
  }

  if (TEST_BITS(infos, BR_INFO_DATA))
  {
    /*fprintf(stderr, ">=> Data    : 0x%08x (0x%08x)\n", infos, CONTROL_DATA);*/
    if (TEST_BITS(infos, CONTROL_DATA))
      SET_BITS(infos, BR_INFO_ERROR);      
    else if (!TEST_BITS(infos, BR_INFO_EXTERN))
      SET_BITS(infos, BR_INFO_DEF);      
    CLEAR_BITS(infos, BR_INFO_EXTERN);
  }
 
  /*----------------------------------------------------  Syntax Unit  --*/
  curr_tok     = SU_tree;
  curr_buf     = SU_buffer;
  last_token   = BR_Null;
  begin_qualif = BR_Null;
  while (curr_tok != BR_Null)
  {
    if (curr_tok == last_token)
    {
      if (   (str_prefix != BR_Null)
          && (((curr_buf - begin_qualif) - 2) == prefix_len)
	  && (strncmp(begin_qualif, str_prefix, prefix_len) == 0))
	curr_buf = begin_qualif;
    }

    if ((curr_tok != SU_tree) && (curr_tok->_prefix != BR_Null))
    {
      last_token          = curr_tok;
      begin_qualif        = curr_buf;
      curr_tok            = APPEND2(curr_tok->_prefix, curr_tok);
      last_token->_prefix = BR_Null;
    }

    curr_val = curr_tok->_val;
    switch(curr_tok->_val_len)
    {
      case 0 :
	break;
      case 1 :
	*curr_buf++ = *curr_val;
	break;
      case 2 :
	*curr_buf++ = *curr_val++;
	*curr_buf++ = *curr_val;
	break;
      case 3 :
	*curr_buf++ = *curr_val++;
	*curr_buf++ = *curr_val++;
	*curr_buf++ = *curr_val;
	break;
      default:
	strncpy(curr_buf, curr_val, curr_tok->_val_len);
	curr_buf += curr_tok->_val_len;
    }
    curr_tok = curr_tok->_next;
  }
  *curr_buf++ = '\0';
  str_SU = SU_buffer;

  /*---------------------------------------------------------------------*/
  if (BR_info_handler != BR_Null)
  {
    if (TEST_BITS(infos, BR_INFO_ERROR))
      BR_info_handler("", "", BR_INFO_ERROR, SU_tree->_line_num);
    else
      BR_info_handler(str_prefix, str_SU, infos, SU_tree->_line_num);
  } 
}


   /*-----------------------------------------------------------------------*/

static RETSIGTYPE
BR_signal_handler()
{
  longjmp(BR_env, 1);
}


   /*-----------------------------------------------------------------------*/

BR_Boolean
BR_parse_file(file_name, info_handler, filter_cmd)
     BR_Str          *file_name;
     BR_InfoHandler   info_handler;
     BR_Str         **filter_cmd;
{
  pid_t       child_pid;
  BR_Boolean  parse_ok;
  FILE*       file_pt;
#if HAVE_BSD_WAITPID
  union wait  child_status;
#else
  int         child_status;
#endif
  int         p_array[2];

  if (file_name == BR_Null)
    parse_ok = BR_FALSE;
  else
  {
    parse_ok = BR_TRUE;
    if (filter_cmd != BR_Null)
    {
      child_pid = -1;
      file_pt   = BR_Null;

      if (pipe(p_array) == -1)
      {
	BR_WARNING(">>>>>  Filter pipe creation failure %s\n", "");
	parse_ok = BR_FALSE;
      }
      else
      {
	child_pid = fork();
	if (child_pid > 0)
	{ /*------------------------------------------------------------*/
	  close(p_array[1]);
	  file_pt = fdopen(p_array[0], "r");
	}
	else if (child_pid == 0)
	{ /*------------------------------------------------------------*/
	  close(1);
	  if (dup(p_array[1]) == -1)
	    fprintf (stderr, "dup failed\n");
	  close(p_array[1]);
	  close(p_array[0]);
	  execv(filter_cmd[0], filter_cmd);
	  BR_FATAL_ERROR(">>>>>  Execv failure (\"%s\")\n", filter_cmd[0]);
	}
	else
        { /*------------------------------------------------------------*/
	  close(p_array[1]);
	  close(p_array[0]);
	  BR_WARNING(">>>>>  Filter fork failure (\"%s\")\n", filter_cmd[0]);
	  parse_ok = BR_FALSE;
	}
      }
    }
    else
    {
      child_pid = 0;
      file_pt   = fopen(file_name, "r");
    }

    if (file_pt != BR_Null)
      BR_lex_init(file_pt, file_name);
    else if (parse_ok != BR_FALSE)
    {
      BR_WARNING(">>>>>  File opening failure (\"%s\")\n", file_name);
      parse_ok = BR_FALSE;
    }

    default_token      = BR_Null;
    global_prefix      = BR_Null;
    template_args      = BR_Null;
    template_flag      = BR_FALSE;
    prefix_stamp       = 1;
    last_stamp         = 0;
    BR_info_handler    = info_handler;
    default_token      = BR_lex_stack_frame(BR_INFO_EMPTY);

    BR_sigill_handler  = signal(SIGILL,  BR_signal_handler);
    BR_sigbus_handler  = signal(SIGBUS,  BR_signal_handler);
    BR_sigsegv_handler = signal(SIGSEGV, BR_signal_handler);

    if (setjmp(BR_env) == 0)
    {
      if ((parse_ok != BR_FALSE) && (BR_yyparse() != 0))
	parse_ok = BR_FALSE;
    }
    else
    {
      fprintf(stderr, ">>>>>\n");
      fprintf(stderr, ">>>>>  Browser Fatal Internal Error (Parsing Aborted)  <<<<<\n");
      fprintf(stderr, ">>>>>     In Parsing file : %s\n", file_name);
      fprintf(stderr, ">>>>>     Near line       : %d\n", BR_lex_get_line_num());
      fprintf(stderr, ">>>>>\n");

      parse_ok = BR_FALSE;
    }

    signal(SIGILL,  BR_sigill_handler);
    signal(SIGBUS,  BR_sigbus_handler);
    signal(SIGSEGV, BR_sigsegv_handler);

    if (file_pt != BR_Null)
      fclose(file_pt);

    if (   (child_pid > 0)
#if HAVE_SYS_WAIT_H || HAVE_BSD_WAITPID
	&& (   (waitpid(child_pid, &child_status, WUNTRACED) != child_pid)
#else
	&& (   (wait(&child_status) != child_pid)
#endif
	    || (WIFEXITED(child_status)   == 0)
	    || (WEXITSTATUS(child_status) != 0)))
      parse_ok = BR_FALSE;
  }

#if C_ALLOCA
  alloca(0);
#endif

  return(parse_ok);
}
